/* 
   Affix - Bluetooth Protocol Stack for Linux
   Copyright (C) 2001,2002 Nokia Corporation
   Author: Dmitry Kasatkin <dmitry.kasatkin@nokia.com>

   Original Author: Guruprasad Krishnamurthy <kgprasad@hotmail.com>

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*
   $Id: attr.h,v 1.21 2003/02/14 15:23:35 kds Exp $

   Fixes:
   		Dmitry Kasatkin		: cleanup, fixes
*/
	 
#ifndef SDP_DYN_ATTR_H
#define SDP_DYN_ATTR_H

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

#include <affix/sdp.h>

#define SDP_PDU_CHUNK_SIZE	1024

void setSequenceLengthPDU(sdppdu_t *pdu);
int appendToPDUForm(sdppdu_t *dst, sdppdu_t *src);

int generatePDUForm(sdppdu_t *pdu, sdpdata_t *pData);
void setSequenceLength(char *ptr, int length);
void generateServiceRecordPDUForm(sdpsvc_t *svcRec);
void attrPDUForm(void * value, void * data);
void addUUIDToTargetPattern(sdpsvc_t *svcRec, uuid_t *uuid);

static inline void addUUID16ToTargetPattern(sdpsvc_t *svcRec, uint16_t uuid16)
{
	uuid_t	uuid;
	sdp_val2uuid16(&uuid, uuid16);
	addUUIDToTargetPattern(svcRec, &uuid);
}

int extractUUID(char *buffer, uuid_t *uuid, int *bytesScanned);

uuid_t *sdp_uuidcpy128(uuid_t *uuid);
sdpsvc_t *clientExtractPDU(char *pdata, uint32_t handleExpected, int *bytesScanned);
int extractAttributes(sdpsvc_t *svcRec, char *localSeqPtr, int sequenceLength);
int attrIdCompareFunc(const void * key1, const void * key2);
void attrPrintFunc(void * value, void * userData); 

void printServiceAttributes(slist_t *pTable);
void printSDPData(sdpdata_t *data);
void printDataSeq(slist_t *dataSeq);
void printPDUForm(sdppdu_t *pdu);

#endif // SDP_DYN_ATTR_H
